package org.cryptomator.ui.mainwindow;

import javafx.beans.binding.Bindings;
import javafx.beans.property.ObjectProperty;
import javafx.collections.ObservableList;
import javafx.scene.control.ListView;
import javafx.scene.layout.AnchorPane;
import org.cryptomator.ui.addvaultwizard.AddVaultWizardComponent;
import org.cryptomator.ui.common.FxController;
import org.cryptomator.ui.model.Vault;

import javax.inject.Inject;

@MainWindowScoped
public class VaultListController implements FxController {

	private final ObservableList<Vault> vaults;
	private final ObjectProperty<Vault> selectedVault;
	private final AddVaultWizardComponent.Builder addVaultWizard;
	public ListView vaultList;
	public AnchorPane onboardingOverlay;

	@Inject
	VaultListController(ObservableList<Vault> vaults, ObjectProperty<Vault> selectedVault, AddVaultWizardComponent.Builder addVaultWizard) {
		this.vaults = vaults;
		this.selectedVault = selectedVault;
		this.addVaultWizard = addVaultWizard;
	}

	public void initialize() {
		onboardingOverlay.visibleProperty().bind(Bindings.isEmpty(vaults));
		vaultList.setItems(vaults);
		selectedVault.bind(vaultList.getSelectionModel().selectedItemProperty());
	}

	public void didClickAddVault() {
		addVaultWizard.build().showAddVaultWizard();
	}

	public void didClickRemoveVault() {
	}
}
